/* Autor: Sergio Blanco Cuaresma
 * Data: Agost 2002
 * Descripci: TAD llista amb funcions especifiques per el programa. Com:
 * - Operaci per avanzar n posicions a partir de la actual
 * - Nombre d'elements que cont
 */

public class Llista {
  private NodeLlista prim, ant;
  private int elements=0;  // Nombre d'elements que tenim

  Llista() throws NoMemoria {
    NodeLlista aux;
    
    try {
      aux = new NodeLlista();    // Creaci del fantasma
    } catch (OutOfMemoryError e) {
      throw new NoMemoria();
    }

    aux.seguent(null);
    this.prim = aux;
    this.ant = aux;
  }

  // Nomes valid per llistes que contenen InfoLlista!!!
  // Mostra per pantalla el contingut de la llista
  void imprimir_cadenes() throws PDIdreta {
    this.principi();
    System.out.println("--  Llistat Webs --");
    while (!this.finalLlista()) {
      System.out.println( ((InfoLlista)(this.actual())).nom() );
      this.avanzar();
    }
    System.out.println("--   Fi Llistat  --");
  }

  // Nomes valid per llistes que contenen Strings!!
  // Mostra per pantalla el contingut de la llista
  void imprimir_llista() throws PDIdreta {
    this.principi();
    System.out.println("--   Llistat Webs  --");
    while (!this.finalLlista()) {
      System.out.println( (String)(this.actual()) );
      this.avanzar();
    }
    System.out.println("-- Fi Llistat --");
  }
  


  void insertar (Object o) throws NoMemoria {
    NodeLlista PDI;
    NodeLlista aux = new NodeLlista();

    if (aux == null) {
      throw new NoMemoria();
    } else {
      aux.info(o);
      PDI = this.ant.seguent();
      this.ant.seguent(aux);
      aux.seguent(PDI);
      this.ant = aux;
    }
    elements++;
  }

  void esborrar() throws PDIdreta {
    NodeLlista PDI;

    PDI = this.ant.seguent();
    if (PDI == null) {
      throw new PDIdreta ();
    } else {
      this.ant.seguent (PDI.seguent());
    }
    elements--;
  }

  Object actual() throws PDIdreta {
    NodeLlista PDI;

    PDI = this.ant.seguent();
    if (PDI == null) {
      throw new PDIdreta();
    } else{
      return PDI.info();
    }
  }

  boolean buida() {
    return (this.prim.seguent() == null);
  }

  void principi() {
    this.ant = this.prim;
  }

  void avanzar() throws PDIdreta {
    NodeLlista PDI;
    PDI = this.ant.seguent();
    
    if (PDI == null) {
      throw new PDIdreta();
    } else {
      this.ant = PDI;
    }
  }

  // Avana n posicions a partir de la posici actual
  void avanzar(int pos) throws PDIdreta {
    NodeLlista PDI;
    PDI = this.ant.seguent();
    
    for (int i=0; i<pos; i++) {
      if (PDI == null) {
        throw new PDIdreta();
      } else {
        this.ant = PDI;
      }
      PDI = this.ant.seguent();
    }
  }

  boolean finalLlista() {
    return (this.ant.seguent() == null);
  }

  // Retorna el nombre d'elements que tenim
  public int elements(){
    return elements;
  }

}
      

