/* Autor: Sergio Blanco Cuaresma
 * Data: Agost 2002
 * Descripci: TAD utilitzat per aplicar l'algorisme de Dijkstra ms fcilment
 */

public class TaulaDijkstra {
  private int[] taula;    // Taula que contindra els valors de les etiquetes acumulats
  private boolean[] fi;   // Taula que indica si aquest valor ja es definitiu
  private int tamany;     // Tamany de les taules

  TaulaDijkstra(int elem){
    taula = new int[elem];
    fi = new boolean[elem];
    for (int i=0;i<elem;i++){
      taula[i]=99999;   // El 99999 representara l'infinit (no es podran ficar etiquetes superiors a 99998)
      fi[i]=false;
    }
    tamany=elem;
  }

  public int valor(int pos){
    return taula[pos];
  }

  public void valor(int pos, int valor){
    taula[pos]=valor;
  }

  public boolean fi(int pos){
    return fi[pos];
  }

  public void fi(int pos, boolean valor){
    fi[pos]=valor;
  }
  
  // Busca en quina posici es troba el valor mnim
  public int minim(){
    int pos;
    boolean ini;
    
    pos = 0;
    ini = true;
    for (int i=0;i<tamany;i++){
      if (ini) {
        if (!fi[i]){
          pos=i;
          ini = false;
        }
      } else {
        if ((taula[i] < taula[pos]) && (!fi[i])) {
          pos = i;
        }
      }
    }
    return pos;
  }
}
